/*
 * Sends  Panasonic EUR7721KD0,Sky(Sky),Sky(TV) or Technika STBHDIS2010  freeview codes. 
 * This program runs on an Arduino board.  It is controlled by the EUR7721KD0.exe program running on a Windows 7 to 10 PC.
 * The EUR7721KD0.exe program can be downloaded from http://www.stevematt.f9.co.uk/EUR7721KD0.
 * 
 * This sketch uses Ken Shirriff's IRRemote library.
 * To compile this sketch you must install that library.
 * For more info see http://www.righto.com/2009/08/multi-protocol-infrared-remote-library.html
 * The most recent code is at github.com/shirriff/Arduino-IRremote. 
 * An IR LED must be connected to your Arduino PWM pin 3.  You must use a 100 ohm resistor in series with the LED.
 *
 * The EUR7721KD0.exe Windows PC program sends key codes to an Arduino via a USB cable when you click on the buttons of the remote control image.
 * The sketch uses the key codes to look up a remote code and sends that out via a infra-red led.
 * If you have an old spare remote you can break it open and use the infra-red LED from that or buy a new LED from a some where.
 * The com port speed settings in the the EUR7721KD0.exe Windows PC program must be the same as in the Serial.begin(115200); 
 * statement in this sketch.  If you want you can use other speeds but they must both match.
 * 
 * You can control other kit by changing the infra-red codes in the array for each remote type, eg in "long TheCode[54]{" in this sketch.
 * Have a look at Ken Shirriff's IRRemote library for how to read remote infra-red codes.
 */
#include <IRremote.h>
 
#define PanasonicAddress      0x4004     // Panasonic address (Pre data) 
#define PanasonicPower        0x100BCBD  // Panasonic Power button

IRsend irsend;

long TheCode[54]{
0xD00BCB1,
0x100BCBD,
0x1002C2D,
0x1000405,
0xD009A97,
0x100A0A1,
0x100ACAD,
0x1008485,
0xD00C3CE,
0xD00D4D9,
0xD000805,
0xD008885,
0xD004845,
0xD002C21,
0xD00C8C5,
0xD002825,
0xD00A8A5,
0xD00ACA1,
0xD006865,
0xD00E8E5,
0xD001815,
0xD00FEF3,
0xD00C1CC,
0xD009895,
0xD00919C,
0xD00323F,
0xD00929F,
0xD00525F,
0xD00202D,
0xD00A0AD,
0xD00000D,
0xD00606D,
0xD00505D,
0xD00D9D4,
0xD00A1AC,
0xD00EAE7,
0xD00E1EC,
0xD00414C,
0xD00111C,
0xD00010C,
0xD00616C,
0xD00818C,
0xD003E33,
0xD004944,
0xD00FAF7,
0xD00D2DF,
0xD001E13,
0xD00222F,
0xD008A87,
0xD00101D,
0xD00C4C9,
0xD007A77,
0xD001A17,
0xD00CCC1,

};
long technikaCode[46]{
0x1FEC03F
,0x1FE18E7
,0x1FE807F
,0x1FE28D7
,0x1FE40BF
,0x1FE00FF
,0x1FEA05F
,0x1FE609F
,0x1FE20DF
,0x1FE906F
,0x1FE50AF
,0x1FEF807
,0x1FEB04F
,0x1FEA25D
,0x1FEE01F
,0x1FEFA05
,0x1FED827
,0x1FEA857
,0x1FE807F
,0x1FE629D
,0x1FEE21D
,0x1FE12ED
,0x1FE926D
,0x1FEF00F
,0x1FE48B7
,0x1FE708F
,0x1FEB847
,0x1FE58A7
,0x1FE30CF
,0x1FE9867
,0x1FEC837
,0x1FE08f7
,0x1FE8877
,0x1FE7887
,0x1FE10EF
,0x1FE38C7
,0x1FE02FD
,0x1FED02F
,0x1FE1AE5
,0x1FE0AF5
,0x1FE8A75
,0x1FE8A75
,0x1FE9A65
,0x1FE5AA5
,0x1FE2AD5
,0x1FEAA55
};

//uint32_t  SkySkyCode[54]{

// uint64_t SkySkyCode[54]{
unsigned long  SkySkyCode[54]{
0xC05C84,
0xC05C80,
0xC05C0C,
0xC05C7D,
0xC05C7E,
0xC05CCC,
0xC05CF5,
0xC18F30CF,
0xC05CCB,
0xC18F08F7,
0xC05C58,
0xC05C20,
0xC05C5A,
0xC05C5C,
0xC05C5B,
0xC18F8877,
0xC05C59,
0xC05C21,
0xC05C3C,
0xC05C83,
0xC05C81,
0xC05C3D,
0xC05C24,
0xC05C28,
0xC05C3E,
0xC05C40,
0xC05C3F,
0xC05C6D,
0xC05C6E,
0xC05C6F,
0xC05C70,
0xC05C01,
0xC05C02,
0xC05C03,
0xC05C04,
0xC05C05,
0xC05C06,
0xC05C07,
0xC05C08,
0xC05C09,
0xC05C00,

  
};

//uint64_t SkyTVCode[54]{
uint32_t  SkyTVCode[54]{
0xC05C80,
0xC18F50AF,
0xC05C7D,
0xC05C7E,
0xC05CCC,
0xC05CF5,
0xC18F30CF,
0xC18FD02F,
0xC18F08F7,
0x0,
0xC18F48B7,
0x0,
0xC18FA45B,
0x0,
0xC18F8877,
0x0,
0xC18FC837,
0x0,
0xC18FE817,
0xC18F7887,
0x0,
0x0,
0x0,
0xC18F24DB,
0x0,
0x0,
0x0,
0x0,
0x0,
0x0,
0xC18F807F,
0xC18F40BF,
0xC18FC03F,
0xC18F20DF,
0xC18FA05F,
0xC18F609F,
0xC18FE01F,
0xC18F10EF,
0xC18F906F,
0xC18F00FF ,
  
};

volatile int CodeIndex = 0;
unsigned long TheCodeValue=0;
//uint64_t  TheCode64Value=0;
//uint32_t  TheCode64Value=0;
unsigned long   TheCode64Value=0;
volatile int NextCommand = 0;
volatile int Command = 0;
volatile int ParamLong = 0;

int loop2;

void setup()
{
    // initialize serial:
  Serial.begin(115200);
}

void loop() {
  
  delayMicroseconds(50);

  loop2 = 1;

   while (Serial.available() > 0) {

    //delay(1000);

    NextCommand = Serial.peek();

    

    switch (NextCommand)
    {
    case 'A':   //Remote style A Panasonic.
    //Serial.println("case A");
    loop2 = 0;
      break;

     case 'B':   //Remote style B Sky (Sky).
    //Serial.println("case B");
  loop2 = 0;
      break;

     case 'C':   //Remote style C Sky (TV).
  //Serial.println("case C");
   loop2 = 0;
       break;

      case 'D':   //Remote style D Technika.
  //Serial.println("case D");
   loop2 = 0;
       break;

   
    default:
    
      NextCommand = Serial.read();  //remove this unknown command.
       loop2 = 1;
      //Serial.println("Switch - Removing unknown command code");
      //Serial.println(NextCommand,HEX);
      //  if (Serial.available() >0)
      //  {
      //      //NextCommand = Serial.peek();
      //      continue;
      //  }
      //  else
      //  {
      //    break;
      //  }
   }

    if(loop2 > 0)
    {
      //Did not get a known command letter so break and test the next character in the stream.
      break;
    }
    
    if (Serial.available() >0)
    {
      //delay not needed because parseInt waits for characters anyway.
       //delay(100);           //Wait so we get the whole string in the buffer.
      NextCommand = Serial.read();
      switch (NextCommand)
      {
        
            case 'A':   //Remote style A Panasonic.
                 CodeIndex = Serial.parseInt()-100;

            if ( (CodeIndex>=0) && (CodeIndex<55))
            {
            TheCodeValue = TheCode[CodeIndex];
            irsend.sendPanasonic(PanasonicAddress,TheCodeValue);
             
            }
          break;
              
       case 'B':   //Remote style B Sky (Sky).
            CodeIndex = Serial.parseInt()-100;
    
          if ( (CodeIndex>=0) && (CodeIndex<55))
          {
             TheCode64Value = SkySkyCode[CodeIndex];
             Serial.println("CodeIndex");
             Serial.println(CodeIndex,HEX);
             Serial.println("TheCode64Value");
             Serial.println(TheCode64Value,HEX);
 
             irsend.sendRC6(TheCode64Value,24);
             TheCode64Value = SkySkyCode[CodeIndex];
             
          }
        break;
             


      
      case 'C':   //Remote style C Sky (TV).
           CodeIndex = Serial.parseInt()-100;
  
            if ( (CodeIndex>=0) && (CodeIndex<55))
            {
            TheCode64Value = SkyTVCode[CodeIndex];
            irsend.sendNEC(TheCode64Value,32);
            }
          break;
          
      case 'D':   //Remote style C Sky (TV).
           CodeIndex = Serial.parseInt()-100;
  
            if ( (CodeIndex>=0) && (CodeIndex<65))
            {
            TheCode64Value = technikaCode[CodeIndex];
            irsend.sendNEC(TheCode64Value,32);
            }
          break;
              //Start = Serial.parseFloat();
        //Start = Serial.parseInt();

  
      default:
        break;
      }

    }

    break;

  }


}
