/*
 * Sends  Panasonic EUR7721KD0,Sky(Sky),Sky(TV) or Technika STBHDIS2010  freeview codes. 
 * This program runs on an Arduino board.  It is controlled by the EUR7721KD0.exe program running on a Windows 7 to 10 PC.
 * The EUR7721KD0.exe program can be downloaded from http://www.stevematt.f9.co.uk/EUR7721KD0.
 * 
 * This is version 2 of myremote.ino sketch. It is now called sender.ino.
 * This was an attemp to use the IRRemote library version 3.6.1 so that I could send the NEC repeat code.
 * I could not get any of the  SendNec functions to send correctly so I have ended up copying some of the version
 * 2.0.1 functions into this file as local functions and using them.  They are renamed and have v2 appended to their names.
 * This file should be compiled with IRRemote library version 3.6.1.
 * This sketch is coded for an Arduino Uno.
 * 
 * This sketch uses Ken Shirriff's IRRemote library.
 * To compile this sketch you must install that library.
 * For more info see http://www.righto.com/2009/08/multi-protocol-infrared-remote-library.html
 * The most recent code is at github.com/shirriff/Arduino-IRremote. 
 * An IR LED must be connected to your Arduino PWM pin 3.  You must use a 100 ohm resistor in series with the LED.
 *
 * The EUR7721KD0.exe Windows PC program sends key codes to an Arduino via a USB cable when you click on the buttons of the remote control image.
 * The sketch uses the key codes to look up a remote code and sends that out via a infra-red led.
 * If you have an old spare remote you can break it open and use the infra-red LED from that or buy a new LED from a some where.
 * The com port speed settings in the the EUR7721KD0.exe Windows PC program must be the same as in the Serial.begin(115200); 
 * statement in this sketch.  If you want you can use other speeds but they must both match.
 * 
 * You can control other kit by changing the infra-red codes in the array for each remote type, eg in "unsigned long TheCode[54]{" in this sketch.
 * Have a look at Ken Shirriff's IRRemote library for how to read remote infra-red codes.
 */
#include <IRremote.h>

#include <Arduino.h>

/*
 * Define macros for input and output pin etc.
 */
//#include "PinDefinitionsAndMore.h"
 
#define PanasonicAddress      0x4004     // Panasonic address (Pre data) 
#define PanasonicPower        0x100BCBD  // Panasonic Power button

#ifdef NEC_BITS
#undef NEC_BITS
#endif

#ifdef NEC_HDR_MARK
#undef NEC_HDR_MARK
#endif

#ifdef NEC_HDR_SPACE
#undef NEC_HDR_SPACE
#endif

#ifdef NEC_BIT_MARK
#undef NEC_BIT_MARK
#endif

#ifdef NEC_ONE_SPACE
#undef NEC_ONE_SPACE
#endif

#ifdef NEC_ZERO_SPACE
#undef NEC_ZERO_SPACE
#endif

#ifdef NEC_RPT_SPACE
#undef NEC_RPT_SPACE
#endif

#ifdef TIMER_INTR_NAME
#undef TIMER_INTR_NAME
#endif

#ifdef TIMER_COUNT_TOP
#undef TIMER_COUNT_TOP
#endif



#define NEC_BITS          32
#define NEC_HDR_MARK    9000
#define NEC_HDR_SPACE   4500
#define NEC_BIT_MARK     560
#define NEC_ONE_SPACE   1690
#define NEC_ZERO_SPACE   560
#define NEC_RPT_SPACE   2250

#	define SYSCLOCK  16000000  // main Arduino clock for uno

#define IR_USE_TIMER2   1


#if defined(IR_USE_TIMER2)

#define TIMER_RESET
#define TIMER_ENABLE_PWM    (TCCR2A |= _BV(COM2B1))
#define TIMER_DISABLE_PWM   (TCCR2A &= ~(_BV(COM2B1)))
#define TIMER_ENABLE_INTR   (TIMSK2 = _BV(OCIE2A))
#define TIMER_DISABLE_INTR  (TIMSK2 = 0)
#define TIMER_INTR_NAME     TIMER2_COMPA_vect

#define TIMER_CONFIG_KHZ(val) ({ \
	const uint8_t pwmval = SYSCLOCK / 2000 / (val); \
	TCCR2A               = _BV(WGM20); \
	TCCR2B               = _BV(WGM22) | _BV(CS20); \
	OCR2A                = pwmval; \
	OCR2B                = pwmval / 3; \
})

#define TIMER_COUNT_TOP  (SYSCLOCK * USECPERTICK / 1000000)

//-----------------
#if (TIMER_COUNT_TOP < 256)
#	define TIMER_CONFIG_NORMAL() ({ \
		TCCR2A = _BV(WGM21); \
		TCCR2B = _BV(CS20); \
		OCR2A  = TIMER_COUNT_TOP; \
		TCNT2  = 0; \
	})
#else
#	define TIMER_CONFIG_NORMAL() ({ \
		TCCR2A = _BV(WGM21); \
		TCCR2B = _BV(CS21); \
		OCR2A  = TIMER_COUNT_TOP / 8; \
		TCNT2  = 0; \
	})
#endif

#endif

void  sendNECv2 (unsigned long data,  int nbits);  //My local copy of version 2.0.1
void  enableIROutv2 (int khz);                      //My local copy of version 2.0.1
void  markv2 (unsigned int time);                  //My local copy of version 2.0.1
void  spacev2 (unsigned int time);                  //My local copy of version 2.0.1
void custom_delay_usecv2(unsigned long uSecs);      //My local copy of version 2.0.1

IRsend irsend;

IRData IRSendData;



unsigned long TheCode[54]{
0xD00BCB1,
0x100BCBD,
0x1002C2D,
0x1000405,
0xD009A97,
0x100A0A1,
0x100ACAD,
0x1008485,
0xD00C3CE,
0xD00D4D9,
0xD000805,
0xD008885,
0xD004845,
0xD002C21,
0xD00C8C5,
0xD002825,
0xD00A8A5,
0xD00ACA1,
0xD006865,
0xD00E8E5,
0xD001815,
0xD00FEF3,
0xD00C1CC,
0xD009895,
0xD00919C,
0xD00323F,
0xD00929F,
0xD00525F,
0xD00202D,
0xD00A0AD,
0xD00000D,
0xD00606D,
0xD00505D,
0xD00D9D4,
0xD00A1AC,
0xD00EAE7,
0xD00E1EC,
0xD00414C,
0xD00111C,
0xD00010C,
0xD00616C,
0xD00818C,
0xD003E33,
0xD004944,
0xD00FAF7,
0xD00D2DF,
0xD001E13,
0xD00222F,
0xD008A87,
0xD00101D,
0xD00C4C9,
0xD007A77,
0xD001A17,
0xD00CCC1,

};

//,0x1FE807F line index 2
//,0x1FE28D7  3
unsigned long technikaCode[46]{
0x1FEC03F
,0x1FE18E7
,0x1FE807F
,0x1FE28D7
,0x1FE40BF
,0x1FE00FF
,0x1FEA05F
,0x1FE609F
,0x1FE20DF
,0x1FE906F
,0x1FE50AF
,0x1FEF807
,0x1FEB04F
,0x1FEA25D
,0x1FEE01F
,0x1FEFA05
,0x1FED827
,0x1FEA857
,0x1FE807F
,0x1FE629D
,0x1FEE21D
,0x1FE12ED
,0x1FE926D
,0x1FEF00F
,0x1FE48B7
,0x1FE708F
,0x1FEB847
,0x1FE58A7
,0x1FE30CF
,0x1FE9867
,0x1FEC837
,0x1FE08f7
,0x1FE8877
,0x1FE7887
,0x1FE10EF
,0x1FE38C7
,0x1FE02FD
,0x1FED02F
,0x1FE1AE5
,0x1FE0AF5
,0x1FE8A75
,0x1FE8A75
,0x1FE9A65
,0x1FE5AA5
,0x1FE2AD5
,0x1FEAA55
};

//uint32_t  SkySkyCode[54]{

// uint64_t SkySkyCode[54]{
unsigned long  SkySkyCode[54]{
0xC05C84,
0xC05C80,
0xC05C0C,
0xC05C7D,
0xC05C7E,
0xC05CCC,
0xC05CF5,
0xC18F30CF,
0xC05CCB,
0xC18F08F7,
0xC05C58,
0xC05C20,
0xC05C5A,
0xC05C5C,
0xC05C5B,
0xC18F8877,
0xC05C59,
0xC05C21,
0xC05C3C,
0xC05C83,
0xC05C81,
0xC05C3D,
0xC05C24,
0xC05C28,
0xC05C3E,
0xC05C40,
0xC05C3F,
0xC05C6D,
0xC05C6E,
0xC05C6F,
0xC05C70,
0xC05C01,
0xC05C02,
0xC05C03,
0xC05C04,
0xC05C05,
0xC05C06,
0xC05C07,
0xC05C08,
0xC05C09,
0xC05C00,

  
};

//uint64_t SkyTVCode[54]{
uint32_t  SkyTVCode[54]{
0xC05C80,
0xC18F50AF,
0xC05C7D,
0xC05C7E,
0xC05CCC,
0xC05CF5,
0xC18F30CF,
0xC18FD02F,
0xC18F08F7,
0x0,
0xC18F48B7,
0x0,
0xC18FA45B,
0x0,
0xC18F8877,
0x0,
0xC18FC837,
0x0,
0xC18FE817,
0xC18F7887,
0x0,
0x0,
0x0,
0xC18F24DB,
0x0,
0x0,
0x0,
0x0,
0x0,
0x0,
0xC18F807F,
0xC18F40BF,
0xC18FC03F,
0xC18F20DF,
0xC18FA05F,
0xC18F609F,
0xC18FE01F,
0xC18F10EF,
0xC18F906F,
0xC18F00FF ,
  
};

volatile int CodeIndex = 0;
unsigned long TheCodeValue=0;
//uint64_t  TheCode64Value=0;
//uint32_t  TheCode64Value=0;
unsigned long   TheCode64Value=0;
volatile int NextCommand = 0;
volatile int Command = 0;
volatile int ParamLong = 0;

int loop2;

void setup()
{
    // initialize serial:
  Serial.begin(115200);
  
  IrSender.begin(3, ENABLE_LED_FEEDBACK);
}

void loop() {
  
  delayMicroseconds(50);

  loop2 = 1;

   while (Serial.available() > 0) {

    //delay(1000);

    NextCommand = Serial.peek();

    

    switch (NextCommand)
    {
    case 'A':   //Remote style A Panasonic.
    //Serial.println("case A");
    loop2 = 0;
      break;

     case 'B':   //Remote style B Sky (Sky).
    //Serial.println("case B");
  loop2 = 0;
      break;

     case 'C':   //Remote style C Sky (TV).
  //Serial.println("case C");
   loop2 = 0;
       break;

      case 'D':   //Remote style D Technika.
  //Serial.println("case D");
   loop2 = 0;
       break;

   
    default:
    
      NextCommand = Serial.read();  //remove this unknown command.
       loop2 = 1;
      //Serial.println("Switch - Removing unknown command code");
      //Serial.println(NextCommand,HEX);
      //  if (Serial.available() >0)
      //  {
      //      //NextCommand = Serial.peek();
      //      continue;
      //  }
      //  else
      //  {
      //    break;
      //  }
   }

    if(loop2 > 0)
    {
      //Did not get a known command letter so break and test the next character in the stream.
      break;
    }
    
    if (Serial.available() >0)
    {
      //delay not needed because parseInt waits for characters anyway.
       //delay(100);           //Wait so we get the whole string in the buffer.
      NextCommand = Serial.read();
      switch (NextCommand)
      {
        
            case 'A':   //Remote style A Panasonic.
                 CodeIndex = Serial.parseInt()-100;

            if ( (CodeIndex>=0) && (CodeIndex<55))
            {
            TheCodeValue = TheCode[CodeIndex];
           // irsend.sendPanasonic(PanasonicAddress,TheCodeValue);
             IrSender.sendPanasonic(PanasonicAddress,TheCodeValue,1);
            }
          break;
              
       case 'B':   //Remote style B Sky (Sky).
            CodeIndex = Serial.parseInt()-100;
    
          if ( (CodeIndex>=0) && (CodeIndex<55))
          {
             TheCode64Value = SkySkyCode[CodeIndex];
             Serial.println("CodeIndex");
             Serial.println(CodeIndex,HEX);
             Serial.println("TheCode64Value");
             Serial.println(TheCode64Value,HEX);
 
             IrSender.sendRC6(TheCode64Value,24);
             TheCode64Value = SkySkyCode[CodeIndex];
             
          }
        break;
             


      
      case 'C':   //Remote style C Sky (TV).
           CodeIndex = Serial.parseInt()-100;
  
            if ( (CodeIndex>=0) && (CodeIndex<55))
            {
            TheCode64Value = SkyTVCode[CodeIndex];
            sendNECv2(TheCode64Value,32);    //My local copy of version 2.0.1
            delay (40);
              //enableIROutv2(38);  //not needed it is already called in sendNECv2
                markv2 (564* 16); spacev2(564*4); markv2(564);spacev2(56*173);
                    //Send Repeat code
                    	spacev2(0);  // Always end with the LED off
 
            }
          break;
          
      case 'D':   //Remote style Technika.
           CodeIndex = Serial.parseInt()-100;
  
            if ( (CodeIndex>=0) && (CodeIndex<65))
            {
            TheCode64Value = technikaCode[CodeIndex];
            
            //I could not get these to work with IRRemote library version 3.6.1.
            //IrSender.sendNEC(TheCode64Value,32,1);
            //IrSender.sendNECMSB(TheCode64Value,32,1);
            //delay (40);
            //IrSender.sendNEC(TheCode64Value,32,1);
            
            sendNECv2(TheCode64Value,32);    //My local copy of version 2.0.1
            delay (40);
              //enableIROutv2(38);  //not needed it is already called in sendNECv2
                markv2 (564* 16); spacev2(564*4); markv2(564);spacev2(56*173);
                    //Send Repeat code
                    	spacev2(0);  // Always end with the LED off
            }
 
            
            
            
          break;
              //Start = Serial.parseFloat();
        //Start = Serial.parseInt();

  
      default:
        break;
      }

    }

    break;

  }


}

//+=============================================================================

void  sendNECv2 (unsigned long data,  int nbits)
{
	// Set IR carrier frequency
	enableIROutv2(38);

	// Header
	markv2(NEC_HDR_MARK);
	spacev2(NEC_HDR_SPACE);

	// Data
	for (unsigned long  mask = 1UL << (nbits - 1);  mask;  mask >>= 1) {
		if (data & mask) {
			markv2(NEC_BIT_MARK);
			spacev2(NEC_ONE_SPACE);
		} else {
			markv2(NEC_BIT_MARK);
			spacev2(NEC_ZERO_SPACE);
		}
	}

	// Footer
	markv2(NEC_BIT_MARK);
	spacev2(0);  // Always end with the LED off
}

//+=============================================================================
// Enables IR output.  The khz value controls the modulation frequency in kilohertz.
// The IR output will be on pin 3 (OC2B).
// This routine is designed for 36-40KHz; if you use it for other values, it's up to you
// to make sure it gives reasonable results.  (Watch out for overflow / underflow / rounding.)
// TIMER2 is used in phase-correct PWM mode, with OCR2A controlling the frequency and OCR2B
// controlling the duty cycle.
// There is no prescaling, so the output frequency is 16MHz / (2 * OCR2A)
// To turn the output on and off, we leave the PWM running, but connect and disconnect the output pin.
// A few hours staring at the ATmega documentation and this will all make sense.
// See my Secrets of Arduino PWM at http://arcfn.com/2009/07/secrets-of-arduino-pwm.html for details.
//
void  enableIROutv2 (int khz)
{
	// Disable the Timer2 Interrupt (which is used for receiving IR)
	TIMER_DISABLE_INTR; //Timer2 Overflow Interrupt

	pinMode(3, OUTPUT);
	digitalWrite(3, LOW); // When not sending PWM, we want it low

	// COM2A = 00: disconnect OC2A
	// COM2B = 00: disconnect OC2B; to send signal set to 10: OC2B non-inverted
	// WGM2 = 101: phase-correct PWM with OCRA as top
	// CS2  = 000: no prescaling
	// The top value for the timer.  The modulation frequency will be SYSCLOCK / 2 / OCR2A.
	TIMER_CONFIG_KHZ(khz);
}

//+=============================================================================
// Sends an IR mark for the specified number of microseconds.
// The mark output is modulated at the PWM frequency.
//
void  markv2 (unsigned int time)
{
	TIMER_ENABLE_PWM; // Enable pin 3 PWM output
	if (time > 0) custom_delay_usecv2(time);
}

//+=============================================================================
// Leave pin off for time (given in microseconds)
// Sends an IR space for the specified number of microseconds.
// A space is no output, so the PWM output is disabled.
//
void  spacev2 (unsigned int time)
{
	TIMER_DISABLE_PWM; // Disable pin 3 PWM output
	if (time > 0) custom_delay_usecv2(time);
}

//+=============================================================================
// Custom delay function that circumvents Arduino's delayMicroseconds limit

void custom_delay_usecv2(unsigned long uSecs) {
  if (uSecs > 4) {
    unsigned long start = micros();
    unsigned long endMicros = start + uSecs - 4;
    if (endMicros < start) { // Check if overflow
      while ( micros() > start ) {} // wait until overflow
    }
    while ( micros() < endMicros ) {} // normal wait
  } 
  //else {
  //  __asm__("nop\n\t"); // must have or compiler optimizes out
  //}
}
